(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@angular/http'), require('rxjs/add/operator/toPromise')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/common', '@angular/core', '@angular/http', 'rxjs/add/operator/toPromise'], factory) :
	(factory((global['ng-tax-share-point-web-services-module'] = {}),global.ng.common,global.ng.core,global.ng.http));
}(this, (function (exports,common,core,http) { 'use strict';

var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var SharepointListsWebService = (function () {
    /**
     * @param {?} http
     */
    function SharepointListsWebService(http$$1) {
        this.http = http$$1;
        this.serviceUrl = '_vti_bin/Lists.asmx';
        this.xmlPayloadWrapperStart = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<soap12:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soap12=\"http://www.w3.org/2003/05/soap-envelope\">\n  <soap12:Body>";
        this.xmlPayloadWrapperEnd = '</soap12:Body></soap12:Envelope>';
        this.getListItemsPayload = "\n    <GetListItems xmlns=\"http://schemas.microsoft.com/sharepoint/soap/\">\n      <listName>listNamePayLoad</listName>\n      <viewName>viewNamePayLoad</viewName>\n      <query>queryPayload</query>\n      <viewFields>viewFieldsPayload</viewFields>\n      <rowLimit>rowLimitPayload</rowLimit>\n      <QueryOptions>queryOptionsPayload</QueryOptions>\n    </GetListItems>";
        this.updateListItemsPayload = "<UpdateListItems xmlns=\"http://schemas.microsoft.com/sharepoint/soap/\"><listName>listNamePayLoad</listName><updates>updatesPayLoad</updates></UpdateListItems>";
        this.headers = new http.Headers({
            'Content-Type': 'application/soap+xml; charset=utf-8',
        });
    }
    /**
     * @param {?} ctor
     * @param {?} filterQuery
     * @param {?} camlQuery
     * @param {?} orderByField
     * @return {?}
     */
    SharepointListsWebService.prototype.getListItems = function (ctor, filterQuery, camlQuery, orderByField) {
        var /** @type {?} */ dummyInstance = new ctor();
        var /** @type {?} */ currentPayload = this.xmlPayloadWrapperStart + this.getListItemsPayload + this.xmlPayloadWrapperEnd;
        currentPayload = currentPayload.replace("listNamePayLoad", dummyInstance.getListName());
        currentPayload = currentPayload.replace("viewNamePayLoad", "");
        if (filterQuery || camlQuery) {
            if (filterQuery) {
                var /** @type {?} */ internalCamlQuery = "<Query><Where><Eq><FieldRef Name='FieldName' /><Value Type='Text'>ValueName</Value></Eq></Where></Query>";
                internalCamlQuery = internalCamlQuery.replace("FieldName", filterQuery[0]);
                internalCamlQuery = internalCamlQuery.replace("ValueName", filterQuery[1]);
                currentPayload = currentPayload.replace("queryPayload", internalCamlQuery);
            }
            else {
                currentPayload = currentPayload.replace("queryPayload", camlQuery);
            }
        }
        else {
            currentPayload = currentPayload.replace("queryPayload", "");
        }
        currentPayload = currentPayload.replace("viewFieldsPayload", "");
        currentPayload = currentPayload.replace("rowLimitPayload", "");
        currentPayload = currentPayload.replace("queryOptionsPayload", "");
        return this.http.post(dummyInstance.getSiteUrl() + this.serviceUrl, currentPayload, { headers: this.headers, })
            .toPromise()
            .then(function (res) {
            var /** @type {?} */ filledResponse = [];
            $(res.text()).find("z\\:row, row").each(function (index) {
                filledResponse.push(new ctor($(this)[0].attributes));
            });
            return filledResponse;
        })
            .catch(this.handleError);
    };
    /**
     * @param {?} itemToUpdate
     * @param {?} newValue
     * @return {?}
     */
    SharepointListsWebService.prototype.updateListItem = function (itemToUpdate, newValue) {
        var /** @type {?} */ currentPayload = this.xmlPayloadWrapperStart + this.updateListItemsPayload + this.xmlPayloadWrapperEnd;
        currentPayload = currentPayload.replace("listNamePayLoad", itemToUpdate.getListName());
        currentPayload = currentPayload.replace("updatesPayLoad", "<Batch OnError=\"Continue\"><Method ID=\"1\" Cmd=\"Update\"><Field Name=\"ID\">" + itemToUpdate.ID + "</Field><Field Name=\"" + itemToUpdate.getFieldToUpdate() + "\">" + newValue + "</Field></Method></Batch>");
        return this.http.post(itemToUpdate.getSiteUrl() + this.serviceUrl, currentPayload, { headers: this.headers, })
            .toPromise()
            .then(function () { return null; })
            .catch(this.handleError);
    };
    /**
     * @param {?} error
     * @return {?}
     */
    SharepointListsWebService.prototype.handleError = function (error) {
        console.error('An error occurred', error); // for demo purposes only
        return Promise.reject(error.message || error);
    };
    /**
     * @param {?} itemToUpdate
     * @param {?} keyValuePairs
     * @return {?}
     */
    SharepointListsWebService.prototype.addOrUpdateListItem = function (itemToUpdate, keyValuePairs) {
        var /** @type {?} */ currentPayload = this.xmlPayloadWrapperStart + this.updateListItemsPayload + this.xmlPayloadWrapperEnd;
        var /** @type {?} */ perColumnString = "<Field Name=\"fieldName\">fieldValue</Field>";
        var /** @type {?} */ allColumnsToUpdate = '';
        var /** @type {?} */ command = "New";
        //if there is an existing 'ID' property with a value, then this is not new but update.
        for (var /** @type {?} */ i = 0; i < keyValuePairs.length; i++) {
            if (keyValuePairs[i][0] == "ID" && keyValuePairs[i][1]) {
                command = "Update";
                break;
            }
        }
        keyValuePairs.forEach(function (entry) { return allColumnsToUpdate = allColumnsToUpdate + perColumnString.replace("fieldName", entry[0]).replace("fieldValue", entry[1]); });
        currentPayload = currentPayload.replace("listNamePayLoad", itemToUpdate.getListName());
        currentPayload = currentPayload.replace("updatesPayLoad", "<Batch OnError=\"Continue\"><Method ID=\"1\" Cmd=\"" + command + "\">" + allColumnsToUpdate + "</Method></Batch>");
        return this.http.post(itemToUpdate.getSiteUrl() + this.serviceUrl, currentPayload, { headers: this.headers, })
            .toPromise()
            .then(function (res) {
            return +$(res.text()).find("z\\:row:first, row:first").attr("ows_ID");
        })
            .catch(this.handleError);
    };
    return SharepointListsWebService;
}());
SharepointListsWebService.decorators = [
    { type: core.Injectable },
];
/**
 * @nocollapse
 */
SharepointListsWebService.ctorParameters = function () { return [
    { type: http.Http, },
]; };
/**
 * Dummy version of an authenticated user service
 */
var UrlService = (function () {
    function UrlService() {
    }
    /**
     * @return {?}
     */
    UrlService.prototype.navigateToDefaultSource = function () {
        if (GetUrlKeyValue('Source', false, window.location.href)) {
            window.location.href = GetUrlKeyValue('Source', false, window.location.href);
        }
        else {
            window.location.href = _spPageContextInfo.webServerRelativeUrl;
        }
    };
    /**
     * @return {?}
     */
    UrlService.prototype.getItemId = function () {
        try {
            return GetUrlKeyValue('ID', false, window.location.href);
        }
        catch (x) {
            return '';
        }
    };
    return UrlService;
}());
UrlService.decorators = [
    { type: core.Injectable },
];
/**
 * @nocollapse
 */
UrlService.ctorParameters = function () { return []; };
var SharePointUserProfile = (function () {
    function SharePointUserProfile() {
    }
    return SharePointUserProfile;
}());
var SharePointUserProfileWebService = (function () {
    /**
     * @param {?} http
     */
    function SharePointUserProfileWebService(http$$1) {
        this.http = http$$1;
        this.serviceUrl = '/_vti_bin/UserProfileService.asmx';
        this.xmlPayloadWrapperStart = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<soap12:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soap12=\"http://www.w3.org/2003/05/soap-envelope\">\n  <soap12:Body>";
        this.xmlPayloadWrapperEnd = '</soap12:Body></soap12:Envelope>';
        this.getUserProfileByNamePayload = "\n    <GetUserProfileByName xmlns=\"http://microsoft.com/webservices/SharePointPortalServer/UserProfileService\">\n      <AccountName>accountNameString</AccountName>\n    </GetUserProfileByName>";
        this.headers = new http.Headers({
            'Content-Type': 'application/soap+xml; charset=utf-8',
        });
    }
    /**
     * @param {?=} accountName
     * @return {?}
     */
    SharePointUserProfileWebService.prototype.getUserProfileByName = function (accountName) {
        var /** @type {?} */ currentPayload = this.xmlPayloadWrapperStart + this.getUserProfileByNamePayload + this.xmlPayloadWrapperEnd;
        if (accountName) {
            currentPayload = currentPayload.replace("accountNameString", accountName);
        }
        else {
            currentPayload = currentPayload.replace("accountNameString", "");
        }
        return this.http.post(this.serviceUrl, currentPayload, { headers: this.headers, })
            .toPromise()
            .then(function (res) {
            var /** @type {?} */ filledResponse = new SharePointUserProfile();
            var /** @type {?} */ jQueryValue = $(res.text()).find("PropertyData:has(name:contains('WorkEmail'))").find('value').text();
            if (jQueryValue) {
                filledResponse.workEmail = jQueryValue;
            }
            jQueryValue = $(res.text()).find("PropertyData:has(name:contains('WorkPhone'))").find('value').text();
            if (jQueryValue) {
                filledResponse.workPhone = jQueryValue;
            }
            $(res.text()).find("z\\:row, row").each(function (index) {
                //$(this)[0].attributes)
                //do some fancy jquery coding here.
            });
            return filledResponse;
        })
            .catch(this.handleError);
    };
    /**
     * @param {?} error
     * @return {?}
     */
    SharePointUserProfileWebService.prototype.handleError = function (error) {
        console.error('An error occurred', error); // for demo purposes only
        return Promise.reject(error.message || error);
    };
    return SharePointUserProfileWebService;
}());
/* return this.http.post(dummyInstance.getSiteUrl()+this.serviceUrl, currentPayload,{headers:this.headers,})
.toPromise()
.then(function(res)
    {
        let filledResponse:SharepointListItem[] = [];
        $(res.text()).find("z\\:row, row").each(function( index:any ) {
            filledResponse.push(new ctor($(this)[0].attributes));
        });
        return filledResponse;
})
.catch(this.handleError);
}



.then(function (res){
    return +$(res.text()).find("z\\:row:first, row:first").attr("ows_ID");
})
.catch(this.handleError);
} */
SharePointUserProfileWebService.decorators = [
    { type: core.Injectable },
];
/**
 * @nocollapse
 */
SharePointUserProfileWebService.ctorParameters = function () { return [
    { type: http.Http, },
]; };
var NgTaxServices = (function () {
    /**
     * @param {?} parentModule
     */
    function NgTaxServices(parentModule) {
        if (parentModule) {
            throw new Error('NgTaxServices / NgTaxSharePointWebServicesModule is already loaded. Import it in the AppModule only');
        }
    }
    /**
     * @return {?}
     */
    NgTaxServices.forRoot = function () {
        return {
            ngModule: NgTaxServices,
            providers: [SharepointListsWebService, UrlService, SharePointUserProfileWebService]
        };
    };
    return NgTaxServices;
}());
NgTaxServices.decorators = [
    { type: core.NgModule, args: [{
                imports: [common.CommonModule],
                declarations: [],
                exports: []
            },] },
];
/**
 * @nocollapse
 */
NgTaxServices.ctorParameters = function () { return [
    { type: NgTaxServices, decorators: [{ type: core.Optional }, { type: core.SkipSelf },] },
]; };
/**
 * @abstract
 */
var SharepointListItem = (function () {
    /**
     * @param {?=} rawResponse
     */
    function SharepointListItem(rawResponse) {
        if (rawResponse) {
            this.ID = +this.findString('ows_id', rawResponse);
            for (var x = 0; x < this.getItemProperties().length; x++) {
                this[this.getItemProperties()[x]] = this.findString('ows_' + this.getItemProperties()[x].toLowerCase(), rawResponse);
            }
        }
    }
    /**
     * @param {?} searchTerm
     * @param {?} myArray
     * @return {?}
     */
    SharepointListItem.prototype.findString = function (searchTerm, myArray) {
        for (var /** @type {?} */ x = 0; x < myArray.length; x++) {
            if (myArray[x].name == searchTerm) {
                return myArray[x].value;
            }
        }
        return '';
    };
    /**
     * @abstract
     * @return {?}
     */
    SharepointListItem.prototype.getSiteUrl = function () { };
    /**
     * @abstract
     * @return {?}
     */
    SharepointListItem.prototype.getListName = function () { };
    /**
     * @abstract
     * @return {?}
     */
    SharepointListItem.prototype.getFieldToUpdate = function () { };
    /**
     * @return {?}
     */
    SharepointListItem.prototype.getItemProperties = function () {
        return [];
    };
    /**
     * @param {?} aString
     * @return {?}
     */
    SharepointListItem.prototype.toBoolean = function (aString) {
        if (this[aString]) {
            this[aString] = this[aString] && this[aString] == "true";
        }
    };
    /**
     * @param {?} aString
     * @return {?}
     */
    SharepointListItem.prototype.toInteger = function (aString) {
        if (this[aString] && this[aString].includes(".")) {
            this[aString] = this[aString].split(".")[0];
        }
    };
    return SharepointListItem;
}());
var UserInfoListEntry = (function (_super) {
    __extends(UserInfoListEntry, _super);
    /**
     * @param {?=} rawResponse
     */
    function UserInfoListEntry(rawResponse) {
        return _super.call(this, rawResponse) || this;
    }
    /**
     * @return {?}
     */
    UserInfoListEntry.prototype.getItemProperties = function () {
        return ["title", "jobTitle", "name", "email"];
    };
    /**
     * @return {?}
     */
    UserInfoListEntry.prototype.getSiteUrl = function () {
        return '/';
    };
    /**
     * @return {?}
     */
    UserInfoListEntry.prototype.getListName = function () {
        return 'User Information List';
    };
    /**
     * @return {?}
     */
    UserInfoListEntry.prototype.getFieldToUpdate = function () {
        return 'Not implemented';
    };
    return UserInfoListEntry;
}(SharepointListItem));

exports.NgTaxServices = NgTaxServices;
exports.SharepointListsWebService = SharepointListsWebService;
exports.UrlService = UrlService;
exports.SharePointUserProfileWebService = SharePointUserProfileWebService;
exports.SharepointListItem = SharepointListItem;
exports.SharePointUserProfile = SharePointUserProfile;
exports.UserInfoListEntry = UserInfoListEntry;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-tax-share-point-web-services-module.umd.js.map
